/************************************************************
 *	FILE DESCRIPTION
 *		\f[^Zbg̗Rs[@\
 *              w肳ꂽ͈̗͂ dst ̒ɃRs[
 *	FILE	:	d3tcpc.c
 *		:	d3tcpc
 *			dsp	:	DSET |C^
 *			from	:	Rs[Jnԍ ( from >= 1 )
 *			to	:	Rs[Iԍ ( to <=  )
 *			dst	:	Rs[ԍ ( 0 <= dst <=  )
 *	REMARKS	:	1988-07-11	M.MOTOKI
 *
 ************************************************************/

#include <stdio.h>
#include "la_ws/include/d3libc.h"
#include "la_ws/include/d3lmac.h"

extern	DMEM	*d3gcmp(), *d3gtra();
extern	char	*malloc(), *calloc(), *d3csav();

static	char	sccsid[]="%Z%%M% %I% %E% %U%";

static	DMEM	*labp, *axip, *labsp, *datp, *dimp, *datap;

d3tcpc(dsp, from, to, dst)
DSET	*dsp;
int	from, to, dst;
{
	int	rn, cn, ncol, err, memno;
						/* `FbN */
	if ((err = tcpc10(dsp, from, to, dst, &rn, &cn)) != 0)
		return(err);

	ncol = to - from + 1;
	memno = PD_MEMNO(dsp);
						/* 񖼂̃Rs[ */
	if ((err = tcpc30(memno, from, dst, ncol)) != 0)
		return(err);
						/* |󕔂̃Rs[ */
	if ((err = tcpc50(memno, from, to, dst, cn, ncol)) != 0)
		return(err);
						/* f[^̃Rs[ */
	if ((err = tcpc70(memno, from, dst, rn, cn, ncol)) != 0)
		return(err);

	return(0);
}

/****************************************************
*	`FbN[`
****************************************************/
static	tcpc10(dsp, from, to, dst, rn, cn)
DSET	*dsp;
int	from, to, dst;
int	*rn, *cn;
{
	if ((datp = d3gcmp(PD_DMEM(dsp), "Dat")) == NULL)
		return(DE_DS_FORMAT);

	if ((datap = d3gcmp(datp, "Data")) == NULL)
		return(DE_PRM);

	if ((dimp = d3gcmp(datp, "Dim")) == NULL)
		return(DE_PRM);

	if (PD_LENGTH(dimp) != 2)
		return(DE_PRM);

	*rn = *PD_VALUE(dimp);
	*cn = *(PD_VALUE(dimp) + 1);

	if (1 <= from	&&
		from <= to	&&
		to   <= *cn	&&
		0    <= dst	&&
		dst  <= *cn)
		;			/* OK */
	else
		return(DE_PRM);

	if ((labp = d3gcmp(PD_DMEM(dsp), "Lab")) == NULL)
		return(DE_DS_FORMAT);

	if ((axip = d3gcmp(labp, "Axi2")) == NULL)
		return(DE_DS_FORMAT);

	if ((labsp = d3gcmp(axip, "Labs")) == NULL)
		return(DE_DS_FORMAT);

	return(0);
}

/****************************************************
*	񖼂̃Rs[
****************************************************/
static	tcpc30(memno, from, dst, ncol)
int	memno, from, dst, ncol;
{
	char	**workp, **wp, **np, **p;
	int	i;

				/* Y񖼂ւ̃|C^[NփRs[ */
	if ((workp = (char **)malloc(ncol * sizeof(char *))) == NULL)
		return(DE_MEM);
	wp = workp;
	np = (char **)PD_VALUE(labsp) + from - 1;
	for (i=0; i<ncol; i++)
		*wp++ = *np++;

				/* [N̊Y񖼂ւ̃|C^
				   񖼂񐬕ɒǉփRs[ */
	if ((np = (char **)d3ient(memno, labsp, dst, ncol)) == NULL) {
		free(workp);
		return(DE_MEM);
	}
	p = np;
	wp = workp;
	for (i=0; i<ncol; i++)
		*p++ = d3csav(memno, *wp++);
	free(workp);

	return(0);
}

/****************************************************
*	|󕔂̃Rs[
****************************************************/
static	tcpc50(memno, from, to, dst, cn, ncol)
int	memno, from, to, dst, cn, ncol;
{
	DMEM	*workp, *wp, *p, *p_1, *p_save;
	int	i, j, pos, err;
	int	copy, shift;		/* JE^ !! */
	char	buf[8];

					/* |󕔂̏Kv */
	for (i=1, copy=0, shift=0; i<=cn; i++) {
		if ((p = (DMEM *)d3gtra(axip, i)) != NULL) {
			if (from <= i && i <= to)
				copy++;		/* |󕔂̃Rs[JEg */
			if (dst < i)
				shift++;	/* |󕔂̃VtgJEg */
		}
	}
	if (copy == 0 && shift == 0)	/*  <JEg>  O Ȃ */
		return(0);		/* Ȃ */

	if (copy) {		/* Y|󕔂[NփRs[ */

		if ((workp = (DMEM *)malloc(copy * sizeof(DMEM))) == NULL)
			return(DE_MEM);

		for (i=0, j=0; j<copy; i++) {
			if ((p = (DMEM *)d3gtra(axip, from + i)) == NULL)
				continue;
			if ((err = d3lcpy(memno, p, &p_1)) != 0) {
				free(workp);
				return(err);
			}
			*(workp + j) = *p_1;
			sprintf(buf, "Tra%d", dst + 1 + i);
			PD_NAME(workp + j) = d3csav(memno, buf);
			j++;
		}
	}

	if (shift) {		/* } Tra ԍVtg */

		for (i=cn, pos=0; i>dst; i--) {
			if ((p = (DMEM *)d3gtra(axip, i)) == NULL)
				continue;
			sprintf(buf, "Tra%d", i + ncol);
			PD_NAME(p) = d3csav(memno, buf);
		}
	}

	if (copy) {		/* [Ñf[^|󕔂ɃRs[ */

					/* }ʒu{ */
		p_save = NULL;
		for (i=1; i<=cn + ncol; i++) {
			if ((p = (DMEM *)d3gtra(axip, i)) != NULL) {
				if (i <= dst)
					p_save = p; /* }ʒuۑ */
				else {
					if (p_save == NULL)
						p_save = p - 1;	/* s߂ */
					break;
				}
			}
		}
					/* Ggԍɕϊ */
		pos = p_save - (DMEM *)PD_VALUE(axip) - 2 + 1;

					/* [Ñf[^|󕔂ɃRs[ */
		if ((p = (DMEM *)d3ient(memno, axip, pos, copy)) == NULL) {
			free(workp);
			return(DE_MEM);
		}
		wp = workp;
		for (i=0; i<copy; i++)
			*p++ = *wp++;

		free(workp);
	}

	return(0);
}

/****************************************************
*	f[^̃Rs[
****************************************************/
static	tcpc70(memno, from, dst, rn, cn, ncol)
int	memno, from, dst, rn, cn, ncol;
{
	int	*workp, *wp, *p;
	int	i, num;

						/* Dim ̍XV */
	*(PD_VALUE(dimp) + 1) += ncol;
						/* Data ̍XV */
	if (rn == 0)
		return(0);

						/* [NAP[g */
	num = ncol * rn;
	if ((workp = (int *)malloc(num * sizeof(int))) == NULL)
		return(DE_MEM);

					/* Y[NɃRs[ */
	wp = workp;
	p = PD_VALUE(datap) + (from - 1)*rn;

	for (i=0; i<num; i++)
		*wp++ = *p++;

				/* [Ñf[^f[^ɃRs[ */
	if ((p = (int *)d3ient(memno, datap, rn * dst, num)) == NULL) {
		free(workp);
		return(DE_MEM);
	}
	wp = workp;
	for (i=0; i<num; i++)
		*p++ = *wp++;

	free(workp);
	return(0);
}
